
gamerule sendCommandFeedback false

# Surface for RTP
forceload add -2 -2 1 1
execute positioned 0 319 0 positioned over world_surface positioned ~ ~-1 ~ if block ~ ~ ~ water run fill ~-32 ~ ~-32 ~31 ~ ~31 light[waterlogged=true,level=0] replace water
forceload remove -2 -2 1 1

# Add scoreboards
function pack:load_scoreboards
function pack:settings

# Revoke all custom advancements
advancement revoke @a only pack:armor_in_inventory
advancement revoke @a only pack:block_in_inventory
advancement revoke @a only pack:hardcore_lock_slots
advancement revoke @a only pack:normal_lock_slots
advancement revoke @a only pack:wood_in_inventory

# Úvodní text | menu
execute unless score .language challenge_settings = .language challenge_settings run scoreboard players set .language challenge_settings 2

execute if predicate pack:admin_mode_disabled if predicate pack:cz run tellraw @a [{"text":"\n"},{"text":"  Challenge Pack 1.3.3 - 1.21.4\n  ","color":"gold"},{"text":"by LibcaJr\n\n  ","color":"light_purple"},{"text":"[","color":"gold","clickEvent":{"action":"run_command","value":"/trigger admin_mode_menu set 1"},"hoverEvent":{"action":"show_text","contents":"Informace o admin módu"}},{"text":"ADMIN MÓD","color":"#E20003","clickEvent":{"action":"run_command","value":"/trigger admin_mode_menu set 1"},"hoverEvent":{"action":"show_text","contents":"Informace o admin módu"}},{"text":"]","color":"gold","clickEvent":{"action":"run_command","value":"/trigger admin_mode_menu set 1"},"hoverEvent":{"action":"show_text","contents":"Informace o admin módu"}},{"text":"\n  "},{"text":"[","color":"aqua"},{"text":"MENU","color":"green","clickEvent":{"action":"run_command","value":"/trigger challenge_settings set 1"},"hoverEvent":{"action":"show_text","contents":"Seznam challengí"}},{"text":"] [","color":"aqua"},{"text":"JAZYK","color":"blue","clickEvent":{"action":"run_command","value":"/trigger language_menu set -1"},"hoverEvent":{"action":"show_text","contents":"Nastavení jazyka datapacku"}},{"text":"] [","color":"aqua"},{"text":"ODSTRANIT","color":"red","clickEvent":{"action":"run_command","value":"/trigger delete_pack set 1"},"hoverEvent":{"action":"show_text","contents":"Odstraní funkce vytvořené datapackem"}},{"text":"]","color":"aqua"},{"text":"\n "}]
execute if predicate pack:admin_mode_enabled if predicate pack:cz run tellraw @a[tag=admin] [{"text":"\n"},{"text":"  Challenge Pack 1.3.3 - 1.21.4\n  ","color":"gold"},{"text":"by LibcaJr\n\n  ","color":"light_purple"},{"text":"[","color":"gold","clickEvent":{"action":"run_command","value":"/trigger admin_mode_menu set 1"},"hoverEvent":{"action":"show_text","contents":"Informace o admin módu"}},{"text":"ADMIN MÓD","color":"#E20003","clickEvent":{"action":"run_command","value":"/trigger admin_mode_menu set 1"},"hoverEvent":{"action":"show_text","contents":"Informace o admin módu"}},{"text":"]","color":"gold","clickEvent":{"action":"run_command","value":"/trigger admin_mode_menu set 1"},"hoverEvent":{"action":"show_text","contents":"Informace o admin módu"}},{"text":"\n  "},{"text":"[","color":"aqua"},{"text":"MENU","color":"green","clickEvent":{"action":"run_command","value":"/trigger challenge_settings set 1"},"hoverEvent":{"action":"show_text","contents":"Seznam challengí"}},{"text":"] [","color":"aqua"},{"text":"JAZYK","color":"blue","clickEvent":{"action":"run_command","value":"/trigger language_menu set -1"},"hoverEvent":{"action":"show_text","contents":"Nastavení jazyka datapacku"}},{"text":"] [","color":"aqua"},{"text":"ODSTRANIT","color":"red","clickEvent":{"action":"run_command","value":"/trigger delete_pack set 1"},"hoverEvent":{"action":"show_text","contents":"Odstraní funkce vytvořené datapackem"}},{"text":"]","color":"aqua"},{"text":"\n "}]
execute if predicate pack:admin_mode_disabled if predicate pack:en run tellraw @a [{"text":"\n"},{"text":"  Challenge Pack 1.3.3 - 1.21.4\n  ","color":"gold"},{"text":"by LibcaJr\n\n  ","color":"light_purple"},{"text":"[","color":"gold","clickEvent":{"action":"run_command","value":"/trigger admin_mode_menu set 1"},"hoverEvent":{"action":"show_text","contents":"Admin mode info"}},{"text":"ADMIN MODE","color":"#E20003","clickEvent":{"action":"run_command","value":"/trigger admin_mode_menu set 1"},"hoverEvent":{"action":"show_text","contents":"Admin mode info"}},{"text":"]","color":"gold","clickEvent":{"action":"run_command","value":"/trigger admin_mode_menu set 1"},"hoverEvent":{"action":"show_text","contents":"Admin mode info"}},{"text":"\n  "},{"text":"[","color":"aqua"},{"text":"MENU","color":"green","clickEvent":{"action":"run_command","value":"/trigger challenge_settings set 1"},"hoverEvent":{"action":"show_text","contents":"List of challenges"}},{"text":"] [","color":"aqua"},{"text":"LANGUAGE","color":"blue","clickEvent":{"action":"run_command","value":"/trigger language_menu set -1"},"hoverEvent":{"action":"show_text","contents":"Datapack language settings"}},{"text":"] [","color":"aqua"},{"text":"DELETE","color":"red","clickEvent":{"action":"run_command","value":"/trigger delete_pack set 1"},"hoverEvent":{"action":"show_text","contents":"Removes features created by the datapack"}},{"text":"]","color":"aqua"},{"text":"\n "}]
execute if predicate pack:admin_mode_enabled if predicate pack:en run tellraw @a[tag=admin] [{"text":"\n"},{"text":"  Challenge Pack 1.3.3 - 1.21.4\n  ","color":"gold"},{"text":"by LibcaJr\n\n  ","color":"light_purple"},{"text":"[","color":"gold","clickEvent":{"action":"run_command","value":"/trigger admin_mode_menu set 1"},"hoverEvent":{"action":"show_text","contents":"Admin mode info"}},{"text":"ADMIN MODE","color":"#E20003","clickEvent":{"action":"run_command","value":"/trigger admin_mode_menu set 1"},"hoverEvent":{"action":"show_text","contents":"Admin mode info"}},{"text":"]","color":"gold","clickEvent":{"action":"run_command","value":"/trigger admin_mode_menu set 1"},"hoverEvent":{"action":"show_text","contents":"Admin mode info"}},{"text":"\n  "},{"text":"[","color":"aqua"},{"text":"MENU","color":"green","clickEvent":{"action":"run_command","value":"/trigger challenge_settings set 1"},"hoverEvent":{"action":"show_text","contents":"List of challenges"}},{"text":"] [","color":"aqua"},{"text":"LANGUAGE","color":"blue","clickEvent":{"action":"run_command","value":"/trigger language_menu set -1"},"hoverEvent":{"action":"show_text","contents":"Datapack language settings"}},{"text":"] [","color":"aqua"},{"text":"DELETE","color":"red","clickEvent":{"action":"run_command","value":"/trigger delete_pack set 1"},"hoverEvent":{"action":"show_text","contents":"Removes features created by the datapack"}},{"text":"]","color":"aqua"},{"text":"\n "}]

# Reload activated challanges
execute if score .xphealth challenge_settings matches 2..3 run function pack:challenges/xphealth/setup
execute if score .hide_in_dark challenge_settings matches 2..3 run function pack:challenges/hide_in_dark/setup
execute if score .no_block_drops challenge_settings matches 2..3 run function pack:challenges/no_block_drops/setup
execute if score .random_mob_sounds challenge_settings matches 2..3 run function pack:challenges/random_mob_sounds/setup
execute if score .no_block_drops challenge_settings matches 2..3 run function pack:challenges/no_crafting/setup
execute if score .mob_swap challenge_settings matches 2..3 run function pack:challenges/mob_swap/setup
execute if score .only_hotbar challenge_settings matches 2..3 run function pack:challenges/only_hotbar/setup

# First use pack | RTP Setup + Challenges to OFF | 1 = disable   2 = enable  3 = hardcore
execute unless score .player_distance rtp_player_distance = .player_distance rtp_player_distance run scoreboard players set .player_distance rtp_player_distance 200
execute unless score .max_distance rtp_max_distance = .max_distance rtp_max_distance run scoreboard players set .max_distance rtp_max_distance 22000
execute unless score .xphealth challenge_settings = .xphealth challenge_settings run scoreboard players set .xphealth challenge_settings 1
execute unless score .hide_in_dark challenge_settings = .hide_in_dark challenge_settings run scoreboard players set .hide_in_dark challenge_settings 1
execute unless score .no_block_drops challenge_settings = .no_block_drops challenge_settings run scoreboard players set .no_block_drops challenge_settings 1
execute unless score .no_armor challenge_settings = .no_armor challenge_settings run scoreboard players set .no_armor challenge_settings 1
execute unless score .no_sounds challenge_settings = .no_sounds challenge_settings run scoreboard players set .no_sounds challenge_settings 1
execute unless score .random_mob_sounds challenge_settings = .random_mob_sounds challenge_settings run scoreboard players set .random_mob_sounds challenge_settings 1
execute unless score .random_knockback challenge_settings = .random_knockback challenge_settings run scoreboard players set .random_knockback challenge_settings 1
execute unless score .no_jump challenge_settings = .no_jump challenge_settings run scoreboard players set .no_jump challenge_settings 1
execute unless score .random_projectiles challenge_settings = .random_projectiles challenge_settings run scoreboard players set .random_projectiles challenge_settings 1
execute unless score .no_crafting challenge_settings = .no_crafting challenge_settings run scoreboard players set .no_crafting challenge_settings 1
execute unless score .no_wood challenge_settings = .no_wood challenge_settings run scoreboard players set .no_wood challenge_settings 1
execute unless score .only_hotbar challenge_settings = .only_hotbar challenge_settings run scoreboard players set .only_hotbar challenge_settings 1
execute unless score .mob_swap challenge_settings = .mob_swap challenge_settings run scoreboard players set .mob_swap challenge_settings 1
execute unless score .half_size challenge_settings = .half_size challenge_settings run scoreboard players set .half_size challenge_settings 1
execute unless score .no_breaking challenge_settings = .no_breaking challenge_settings run scoreboard players set .no_breaking challenge_settings 1

# Data preload
data merge storage challenge:menu {page: 1b}
execute store result storage challenge:random_mob_sounds x byte 1 run random value -5..5
execute store result storage challenge:random_mob_sounds y byte 1 run random value -3..3
execute store result storage challenge:random_mob_sounds z byte 1 run random value -5..5
execute store result storage challenge:rtp distance.player int 1 run scoreboard players get .player_distance rtp_player_distance
execute store result storage challenge:rtp distance.max int 1 run scoreboard players get .max_distance rtp_max_distance

# Disable triggers
execute as @a run function pack:challenges/reset/all_triggers

# Enable triggers
execute if predicate pack:admin_mode_disabled run scoreboard players enable @a pack_info
execute if predicate pack:admin_mode_disabled run scoreboard players enable @a delete_pack
execute if predicate pack:admin_mode_disabled run scoreboard players enable @a challenge_settings
execute if predicate pack:admin_mode_disabled run scoreboard players enable @a language_menu
execute if predicate pack:admin_mode_disabled run scoreboard players enable @a admin_mode_menu
execute if predicate pack:admin_mode_enabled run scoreboard players enable @a[tag=admin] pack_info
execute if predicate pack:admin_mode_enabled run scoreboard players enable @a[tag=admin] delete_pack
execute if predicate pack:admin_mode_enabled run scoreboard players enable @a[tag=admin] challenge_settings
execute if predicate pack:admin_mode_enabled run scoreboard players enable @a[tag=admin] language_menu
execute if predicate pack:admin_mode_enabled run scoreboard players enable @a[tag=admin] admin_mode_menu